// import remark from 'remark';
// import { unified } from 'unified';
// import remark_directive from 'remark-directive';
// import { VFile } from 'vfile';

// import markdownFrontmatterLinterPlugin from '../index';

// const processMarkdown = (md, opts): VFile => {
//     return await remark()
//         .use(markdownFrontmatterLinterPlugin as unified.Attacher, opts)
//         .use(remark_directive)
//         .process(md);
// };

// describe('validateFrontMatter Rule', () => {
//     test('should not return errors for valid front-matter', () => {
//         const markdown = `
//         ---
//         examples:
//             - name: basic
//               label: Basic Buttons
//               description: Button variants display buttons with different colors to convey meanings.
//         ---
//         # Valid Content
//         This is valid Markdown with correct front-matter.
//         `;

//         const file = vfile({ path: '/test/content/guides/button.md', contents: markdown });
//         const result = processMarkdown(file, {});
//         expect(result.messages).toHaveLength(0);
//     });

//     // test('should return errors for invalid front-matter (missing required property)', () => {
//     //     const markdown = `
//     //         ---
//     //         examples:
//     //         - label: Missing Name
//     //             description: This example is missing the name property.
//     //         ---
//     //         # Invalid Content
//     //         This content has invalid front-matter.
//     //         `;

//     //     const file = processMarkdown(markdown);
//     //     expect(file.messages.length).toBe(1);
//     //     expect(file.messages[0].message).toContain('must have required property');
//     //     expect(file.messages[0].message).toContain('name');
//     // });

//     // test('should return errors for invalid front-matter (empty required property)', () => {
//     //     const markdown = `
//     //         ---
//     //         examples:
//     //         - name: ""
//     //             label: Empty Name
//     //             description: This example has an empty name property.
//     //         ---
//     //         # Invalid Content
//     //         This content has invalid front-matter.
//     //         `;

//     //     const file = processMarkdown(markdown);
//     //     expect(file.messages.length).toBe(1);
//     //     expect(file.messages[0].message).toContain('must NOT have fewer than 1 characters');
//     //     expect(file.messages[0].message).toContain('/examples/0/name');
//     // });

//     // test('should return multiple errors for multiple invalid examples', () => {
//     //     const markdown = `
//     //         ---
//     //         examples:
//     //         - label: Missing Name
//     //             description: This example is missing the name property.
//     //         - name: ""
//     //             label: Empty Name
//     //             description: This example has an empty name property.
//     //         ---
//     //         # Invalid Content
//     //         This content has multiple invalid examples in front-matter.
//     //         `;

//     //     const file = processMarkdown(markdown);
//     //     expect(file.messages.length).toBe(2);

//     //     expect(file.messages[0].message).toContain('must have required property');
//     //     expect(file.messages[0].message).toContain('name');

//     //     expect(file.messages[1].message).toContain('must NOT have fewer than 1 characters');
//     //     expect(file.messages[1].message).toContain('/examples/1/name');
//     // });

//     // test('should ignore files without front-matter', () => {
//     //     const markdown = `
//     //         # Markdown Without Front-Matter
//     //         This file does not contain any front-matter.
//     //         `;

//     //     const file = processMarkdown(markdown);
//     //     expect(file.messages.length).toBe(0);
//     // });
// });

import remark from 'remark';
import remark_directive from 'remark-directive';
import unified from 'unified';
import vfile, { VFile } from 'vfile';
import dedent from 'dedent';

import markdownFrontmatterLinterPlugin from '../index';

const processMarkdown = async (md, opts): Promise<VFile> => {
    return remark()
        .use(markdownFrontmatterLinterPlugin as unified.Attacher, opts)
        .use(remark_directive)
        .processSync(md);
};

describe('sfdocs-lint:remark-lint-markdown-frontmatter-playground', () => {
    test('should not return errors for valid front-matter', () => {
        const validMarkdown = dedent(`
        ---
         examples:
             - name: basic
               label: Basic Buttons
               description: Button variants display buttons with different colors to convey meanings.
        ---
         # Valid Content
         This is valid Markdown with correct front-matter.
        `);
        const file = vfile({ path: '/test/content/guides/button-example.md', contents: validMarkdown });
        const result = processMarkdown(file, {});
        // expect(result.messages).toHaveLength(0);
    });
});